/********************************** (C) COPYRIGHT *******************************
* File Name          : CH9434.h
* Author             : tech18
* Version            : V1.0
* Date               : 2020/05/08
* Description        : SPIתоƬCH9434ӿͷļ
*******************************************************************************/

/******************************************************************************/
#ifndef __CH9434_H
#define __CH9434_H

#ifdef __cplusplus
extern "C"
{
#endif

/* -----------------------------------------------------------------------------
 *                                   Ͷ
 * -----------------------------------------------------------------------------
 */
#ifndef u8_t
typedef unsigned char                   u8_t;
#endif
#ifndef u16_t
typedef unsigned short                  u16_t;
#endif
#ifndef u32_t
typedef unsigned long                   u32_t;
#endif

/* -----------------------------------------------------------------------------
 *                       ⲿӿں--û㶨
 * -----------------------------------------------------------------------------
 */
/* USʱ */
extern void CH9434_US_DELAY(void);

/* SPIӿSCSſƣ0͵ƽ  1ߵƽ */ 
extern void CH9434_SPI_SCS_OP(u8_t dat);

/* SPIһֽڽӿ */
extern u8_t CH9434_SPI_WRITE_BYTE(u8_t dat);


/* -----------------------------------------------------------------------------
 *                                   궨
 * -----------------------------------------------------------------------------
 */
/* ʹλ */
#define CH9434_ENABLE                   1
#define CH9434_DISABLE                  0

/* ں */
#define CH9434_UART_IDX_0               0
#define CH9434_UART_IDX_1               1
#define CH9434_UART_IDX_2               2
#define CH9434_UART_IDX_3               3

/* Ĵ */
#define CH9434_REG_OP_WRITE             0x80
#define CH9434_REG_OP_READ              0x00

/* Ĵ */
#define CH9434_UART0_REG_OFFSET_ADD     0x00
#define CH9434_UART1_REG_OFFSET_ADD     0x10
#define CH9434_UART2_REG_OFFSET_ADD     0x20
#define CH9434_UART3_REG_OFFSET_ADD     0x30
	#define CH9434_UARTx_RBR_ADD          0
	#define CH9434_UARTx_THR_ADD          0
	#define CH9434_UARTx_IER_ADD          1
	#define CH9434_UARTx_IIR_ADD          2
	#define CH9434_UARTx_FCR_ADD          2
	#define CH9434_UARTx_LCR_ADD          3
		#define CH9434_UARTx_BIT_DLAB       (1<<7)
	#define CH9434_UARTx_MCR_ADD          4
	#define CH9434_UARTx_LSR_ADD          5
	#define CH9434_UARTx_MSR_ADD          6
	#define CH9434_UARTx_SCR_ADD          7
	#define CH9434_UARTx_DLL_ADD          0
	#define CH9434_UARTx_DLM_ADD          1

//TNOW UART
#define CH9434_TNOW_CTRL_CFG_ADD        0x41
	#define CH9434_BIT_TNOW_OUT_POLAR     0xF0
	#define CH9434_BIT_TNOW_OUT_EN        0x0F
#define CH9434_FIFO_CTRL_ADD            0x42
	#define CH9434_FIFO_CTRL_TR           (1<<4)
	#define CH9434_FIFO_UART_IDX          0x0F
#define CH9434_FIFO_CTRL_L_ADD	        0x43
#define CH9434_FIFO_CTRL_H_ADD	        0x44

//Դʱ
#define CH9434_CLK_CTRL_CFG_ADD         0x48
	#define CH9434_CLK_CTRL_MOD           (3<<6)
	#define CH9434_XT_POWER_EN            (1<<5)
	#define CH9434_CLK_DIV_MASK           0x1F
#define CH9434_SLEEP_MOD_CFG_ADD        0x4A

//GPIO //GPIOʹ
#define CH9434_GPIO_FUNC_EN_0           0x50
#define CH9434_GPIO_FUNC_EN_1           0x51
#define CH9434_GPIO_FUNC_EN_2           0x52
#define CH9434_GPIO_FUNC_EN_3           0x53
//GPIOѡ
#define CH9434_GPIO_DIR_MOD_0           0x54
#define CH9434_GPIO_DIR_MOD_1           0x55
#define CH9434_GPIO_DIR_MOD_2           0x56
#define CH9434_GPIO_DIR_MOD_3           0x57
//GPIO
#define CH9434_GPIO_PU_MOD_0            0x58
#define CH9434_GPIO_PU_MOD_1            0x59
#define CH9434_GPIO_PU_MOD_2            0x5A
#define CH9434_GPIO_PU_MOD_3            0x5B
//GPIO
#define CH9434_GPIO_PD_MOD_0            0x5C
#define CH9434_GPIO_PD_MOD_1            0x5D
#define CH9434_GPIO_PD_MOD_2            0x5E
#define CH9434_GPIO_PD_MOD_3            0x5F
//GPIOŵƽ
#define CH9434_GPIO_PIN_VAL_0           0x60
#define CH9434_GPIO_PIN_VAL_1           0x61
#define CH9434_GPIO_PIN_VAL_2           0x62
#define CH9434_GPIO_PIN_VAL_3           0x63

/* ڲ */
/* FIFO Size */
#define CH9434_UART_FIFO_MODE_256       0         //256
#define CH9434_UART_FIFO_MODE_512       1         //512
#define CH9434_UART_FIFO_MODE_1024      2         //1024
#define CH9434_UART_FIFO_MODE_1280      3         //1280
/* Character Size */
#define CH9434_UART_5_BITS_PER_CHAR     5
#define CH9434_UART_6_BITS_PER_CHAR     6
#define CH9434_UART_7_BITS_PER_CHAR     7
#define CH9434_UART_8_BITS_PER_CHAR     8
/* Stop Bits */
#define CH9434_UART_ONE_STOP_BIT        1
#define CH9434_UART_TWO_STOP_BITS       2
/* Parity settings */
#define CH9434_UART_NO_PARITY           0x00                              //У
#define CH9434_UART_ODD_PARITY          0x01                              //У
#define CH9434_UART_EVEN_PARITY         0x02                              //żУ
#define CH9434_UART_MARK_PARITY         0x03                              //1 mark
#define CH9434_UART_SPACE_PARITY        0x04                              //հ0 SPACE

/* TNOW */
#define CH9434_TNOW_POLAR_NORMAL        0                                 //
#define CH9434_TNOW_POLAR_OPPO          1                                 //
               
#define CH9434_TNOW_0                   0
#define CH9434_TNOW_1                   1
#define CH9434_TNOW_2                   2
#define CH9434_TNOW_3                   3

/* ͹ģʽ */
#define CH9434_LOWPOWER_INVALID         0
#define CH9434_LOWPOWER_SLEEP           1

/* GPIO */
#define CH9434_GPIO_0                   0
#define CH9434_GPIO_1                   1
#define CH9434_GPIO_2                   2
#define CH9434_GPIO_3                   3
#define CH9434_GPIO_4                   4
#define CH9434_GPIO_5                   5
#define CH9434_GPIO_6                   6
#define CH9434_GPIO_7                   7
#define CH9434_GPIO_8                   8
#define CH9434_GPIO_9                   9
#define CH9434_GPIO_10                  10
#define CH9434_GPIO_11                  11
#define CH9434_GPIO_12                  12
#define CH9434_GPIO_13                  13
#define CH9434_GPIO_14                  14
#define CH9434_GPIO_15                  15
#define CH9434_GPIO_16                  16
#define CH9434_GPIO_17                  17
#define CH9434_GPIO_18                  18
#define CH9434_GPIO_19                  19
#define CH9434_GPIO_20                  20
#define CH9434_GPIO_21                  21
#define CH9434_GPIO_22                  22
#define CH9434_GPIO_23                  23
#define CH9434_GPIO_24                  24

/* GPIOʹ */
#define CH9434_GPIO_ENABLE              1
#define CH9434_GPIO_DISABLE             0
 
/* GPIO */
#define CH9434_GPIO_DIR_IN              0
#define CH9434_GPIO_DIR_OUT             1
 
/* GPIOʹ */
#define CH9434_GPIO_PU_ENABLE           1
#define CH9434_GPIO_PU_DISABLE          0

/* GPIOʹ */
#define CH9434_GPIO_PD_ENABLE           1
#define CH9434_GPIO_PD_DISABLE          0

/* GPIO */
#define CH9434_GPIO_SET                 1
#define CH9434_GPIO_RESET               0

/* -----------------------------------------------------------------------------
 *                                  ӿں
 * -----------------------------------------------------------------------------
 */
/*******************************************************************************
* Function Name  : CH9434OscXtFreqSet
* Description    : ⲿƵʼ¼
* Input          : x_freqǰоƬӵľƵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434OscXtFreqSet(u32_t x_freq);
/*******************************************************************************
* Function Name  : CH9434InitClkMode
* Description    : CH9434оƬʱģʽ
* Input          : xt_enⲿʹ
                   freq_mul_enƵʹ
                   div_numƵϵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434InitClkMode(u8_t xt_en,u8_t freq_mul_en,u8_t div_num);
/*******************************************************************************
* Function Name  : CH9434UARTxParaSet
* Description    : ڲ
* Input          : uart_idxں
                   bpsڵĲ
                   data_bitsλ
                   stop_bitsֹͣλ
                   veri_bitsУλ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxParaSet(u8_t uart_idx,u32_t bps,u8_t data_bits,u8_t stop_bits,u8_t veri_bits);
/*******************************************************************************
* Function Name  : CH9434UARTxFIFOSet
* Description    : FIFO
* Input          : uart_idxں
                   fifo_enFIFOʹ
                   fifo_levelFIFOȼ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxFIFOSet(u8_t uart_idx,u8_t fifo_en,u8_t fifo_level);
/*******************************************************************************
* Function Name  : CH9434UARTxIrqSet
* Description    : ж
* Input          : uart_idxں
                   modemmodemźж
                   line·״̬ж
                   txж
                   rxж
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxIrqSet(u8_t uart_idx,u8_t modem,u8_t line,u8_t tx,u8_t rx);
/*******************************************************************************
* Function Name  : CH9434UARTxFlowSet
* Description    : 
* Input          : uart_idxں
                   flow_enʹ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxFlowSet(u8_t uart_idx,u8_t flow_en);
/*******************************************************************************
* Function Name  : CH9434UARTxIrqOpen
* Description    : жϴ
* Input          : uart_idxں
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxIrqOpen(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxRtsDtrPin
* Description    : ôRTSDTR
* Input          : uart_idxں
                   rts_valRTSŵƽ״̬
                   dtr_valDTRŵƽ״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxRtsDtrPin(u8_t uart_idx,u8_t rts_val,u8_t dtr_val);
/*******************************************************************************
* Function Name  : CH9434UARTxWriteSRC
* Description    : SRCĴд
* Input          : uart_idxں
                   src_valSRCĴֵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxWriteSRC(u8_t uart_idx,u8_t src_val);
/*******************************************************************************
* Function Name  : CH9434UARTxReadSRC
* Description    : SRCĴ
* Input          : uart_idxں
* Output         : None
* Return         : SRCĴֵ
*******************************************************************************/
u8_t CH9434UARTxReadSRC(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxReadIIR
* Description    : жѯ
* Input          : uart_idxں
* Output         : None
* Return         : IIRĴֵ
*******************************************************************************/
u8_t CH9434UARTxReadIIR(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxReadLSR
* Description    : LSRĴȡ
* Input          : uart_idxں
* Output         : None
* Return         : LSRĴֵ
*******************************************************************************/
u8_t CH9434UARTxReadLSR(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxReadMSR
* Description    : MSRĴȡ
* Input          : uart_idxں
* Output         : None
* Return         : MSRĴֵ
*******************************************************************************/
u8_t CH9434UARTxReadMSR(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxGetRxFIFOLen
* Description    : ȡڽݳ
* Input          : uart_idxں
* Output         : None
* Return         : ڽFIFOĴС
*******************************************************************************/
u16_t CH9434UARTxGetRxFIFOLen(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxGetRxFIFOData
* Description    : ȡڽ
* Input          : uart_idxں
                   p_dataݴ洢ָ
                   read_lenȡݳ
* Output         : None
* Return         : 
*******************************************************************************/
u8_t CH9434UARTxGetRxFIFOData(u8_t uart_idx,u8_t *p_data,u16_t read_len);
/*******************************************************************************
* Function Name  : CH9434UARTxGetTxFIFOLen
* Description    : ȡڷFIFO
* Input          : uart_idxں
* Output         : None
* Return         : ǰڵĽݳ
*******************************************************************************/
u16_t CH9434UARTxGetTxFIFOLen(u8_t uart_idx);
/*******************************************************************************
* Function Name  : CH9434UARTxGetRxFIFOData
* Description    : 뷢
* Input          : uart_idxں
                   p_dataָ
                   send_len͵ݳ
* Output         : None
* Return         : 
*******************************************************************************/
u8_t CH9434UARTxSetTxFIFOData(u8_t uart_idx,u8_t *p_data,u16_t send_len);
/*******************************************************************************
* Function Name  : CH9434UARTxTnowSet
* Description    : 485л
* Input          : uart_idxں
                   tnow_entnowʹ״̬
                   polarԷ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434UARTxTnowSet(u8_t uart_idx,u8_t tnow_en,u8_t polar);
/*******************************************************************************
* Function Name  : CH9434LowerPowerModeSet
* Description    : CH9434оƬ͹
* Input          : mode͹ģʽ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434LowerPowerModeSet(u8_t mode);
/*******************************************************************************
* Function Name  : CH9434WakeUp
* Description    : CH9434Ѳӵ͹ģʽл
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434WakeUp(void);
/*******************************************************************************
* Function Name  : CH9434GPIOFuncSet
* Description    : GPIO
* Input          : gpio_idxGPIO
                   enʹ״̬
                   dirGPIO
                   pu
                   pd
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434GPIOFuncSet(u8_t gpio_idx,u8_t en,u8_t dir,u8_t pu,u8_t pd);
/*******************************************************************************
* Function Name  : CH9434GPIOPinOut
* Description    : GPIOƽ
* Input          : gpio_idxGPIO
                   out_valƽ
* Output         : None
* Return         : None
*******************************************************************************/
void CH9434GPIOPinOut(u8_t gpio_idx,u8_t out_val);
/*******************************************************************************
* Function Name  : CH9434GPIOPinVal
* Description    : GPIOƽȡ
* Input          : gpio_idxGPIO
* Output         : None
* Return         : ƽ״̬1ߵƽ 0͵ƽ
*******************************************************************************/
u8_t CH9434GPIOPinVal(u8_t gpio_idx);



/******************************************************************************/
#ifdef __cplusplus
}
#endif

#endif